(***************************************************************************
 *
 * Expression Tree Interface
 *
 * Author: Gerald Baumgartner
 * Date:   27 October 2001
 * Date:   11 October 2009
 *
 ***************************************************************************)

signature EXP_TREE =
  sig
    eqtype iSet
    eqtype iSetSeq

    datatype arithOp = Add | Sub | Mul | Div

    datatype expTree = Array of string * (string * int) list
		     | Fun of string * (string * int) list
		     | IntLit of IntInf.int
		     | Output of expTree
		     | Cast of (string * int) list * expTree
		     | Sum of string list * expTree
		     | BinOp of arithOp * expTree * expTree

    val fusible : expTree -> iSet
    val indices : expTree -> iSet
    val indexList : expTree -> string list
    val fusedSize : expTree * iSetSeq -> IntInf.int
    val recomputationCost : expTree * iSetSeq -> IntInf.int
    val toString : expTree -> string
    val toExp : expTree -> string
  end
