(***************************************************************************
 *
 * Set Interface
 *
 * Author: Gerald Baumgartner
 * Date:   27 October 2001
 *
 ***************************************************************************)

signature SET =
  sig
    eqtype t
    eqtype 'a set

    val empty : t set
    val isEmpty : t set -> bool
    val elem : t * t set -> bool
    val subset : t set * t set -> bool
    val eq : t set * t set -> bool
    val union : t set * t set -> t set
    val intersect : t set * t set -> t set
    val Union : t set list -> t set
    val Intersect : t set list -> t set
    val difference : t set * t set -> t set
    val powerSet : t set -> t set set
    val crossProduct : t set * t set -> (t * t) set
    val setMap : (t -> 'a) -> t set -> 'a list
    val toString : t set -> string
  end
