(***************************************************************************
 *
 * Solution Interface
 *
 * Author: Gerald Baumgartner
 * Date:   18 September 2001
 * Date:   18 March 2010
 *
 ***************************************************************************)

signature SOLUTION =
  sig
    eqtype iSet
    eqtype iSetSeq
    eqtype expTree

    datatype sol = S of iSetSeq *
			(IntInf.int * IntInf.int * IntInf.int * IntInf.int) *
			(iSet * IntInf.int * IntInf.int * expTree) list *
			IntInf.int * expTree

    eqtype solSet

    exception IllegalExpressionTree

    val getFusion : sol -> iSetSeq

    val setCostModelDetails : bool option -> bool
    val setCostModelAllocation : bool option -> bool

    val setMemoryLimit : IntInf.int -> unit
    val clearMemoryLimit : unit -> unit
    val exceedsMemoryLimit : IntInf.int -> bool
    val setFunctionCost : IntInf.int -> unit

    val makeLeafSoln : expTree * iSet -> solSet
    val makeUnarySoln : sol * expTree * iSet -> sol
    val makeBinarySoln : sol * sol * expTree * iSet -> sol
    val extendSoln : sol * iSetSeq * iSet -> sol
    val reduceSoln : sol * iSet -> sol
    val inferior : sol * sol -> bool

    val toString : sol -> string
  end
