(***************************************************************************
 *
 * Test Suite for the Fusion Algorithm
 *
 * Author: Gerald Baumgartner
 * Date:   3 June 2001
 * Date:   1 October 2009
 *
 ***************************************************************************)


(* For old CM: *)

    (* For making CM.autoload' work, for some reason it is necessary to
     * copy smlnj-lib.cm from SMLNJ_HOME/lib into the working directory.  
     * The environment variable CM_PATH is supposed to tell CM where to
     * find the *.cm files, but that does not seem to work.
     *)

(*
    CM.autoloading (SOME true);
    CM.autoload' "smlnj-lib.cm";
 *)

(* For new CM: *)

    CM.autoload "$/smlnj-lib.cm";


use "TestSet.sml";		(* tests for the set implementation *)
use "TestIndexSet.sml";		(* tests for the indexset implementation *)
use "TestIndexSetSeq.sml";	(* tests for indexset sequences *)
use "TestExpTree.sml";		(* tests for expression trees *)
				(* nothing to test for Solution.sml *)
use "TestSolTree.sml";		(* tests for solution trees *)
use "TestFusionTree.sml";	(* tests for fusion trees *)

val ok =
    TestSet.ok
    andalso TestIndexSet.ok
    andalso TestIndexSetSeq.ok
    andalso TestExpTree.ok
    andalso TestSolTree.ok
    andalso TestFusionTree.ok
