# From Marcel's file of equations

range 300 a,b,c,d
range  70 e,f
range  40 i,j,k,l

# *************************************************************
# *************************************************************
# Explicit Equations Part A:  CCSD Equations
# *************************************************************
# *************************************************************

# The following definitions would result in correct code, but
# the generated functions will clash with later functions of
# the same name.
#hbar[a,i]==0
#hbar[a,b,i,j]==0

hbar[a,i]==
f[a,i]
+sum[f[a,c]*t[i,c],{c}]
-sum[f[k,i]*t[k,a],{k}]
-sum[f[k,c]*t[i,c]*t[k,a],{k,c}]
+2*sum[f[k,c]*t[i,k,a,c],{k,c}]
-sum[f[k,c]*t[i,k,c,a],{k,c}]
-sum[t[i,c]*t[k,d]*v[k,a,c,d],{k,c,d}]
-sum[t[i,k,c,d]*v[k,a,c,d],{k,c,d}]
+2*sum[t[k,c]*v[k,a,c,i],{k,c}]
+2*sum[t[i,c]*t[k,d]*v[k,a,d,c],{k,c,d}]
+2*sum[t[i,k,c,d]*v[k,a,d,c],{k,c,d}]
-sum[t[k,c]*v[k,a,i,c],{k,c}]
-2*sum[t[i,c]*t[k,a]*t[l,d]*v[k,l,c,d],{k,l,c,d}]
+4*sum[t[l,d]*t[i,k,a,c]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[l,d]*t[i,k,c,a]*v[k,l,c,d],{k,l,c,d}]
+sum[t[l,a]*t[i,k,c,d]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[i,c]*t[k,l,a,d]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[k,c]*t[l,a]*v[k,l,c,i],{k,l,c}]
+sum[t[k,a]*t[l,c]*v[k,l,c,i],{k,l,c}]
+sum[t[k,l,a,c]*v[k,l,c,i],{k,l,c}]
-2*sum[t[l,k,a,c]*v[k,l,c,i],{k,l,c}]
-2*sum[t[l,d]*t[i,k,a,c]*v[k,l,d,c],{k,l,c,d}]
+sum[t[l,d]*t[i,k,c,a]*v[k,l,d,c],{k,l,c,d}]
-2*sum[t[l,a]*t[i,k,c,d]*v[k,l,d,c],{k,l,c,d}]
+sum[t[i,c]*t[k,a]*t[l,d]*v[l,k,c,d],{k,l,c,d}]
+sum[t[i,c]*t[k,l,a,d]*v[l,k,c,d],{k,l,c,d}]

hbar[a,b,i,j]==
sum[f[b,c]*t[i,j,a,c],{c}]
-sum[f[k,c]*t[k,b]*t[i,j,a,c],{k,c}]
+sum[f[a,c]*t[i,j,c,b],{c}]
-sum[f[k,c]*t[k,a]*t[i,j,c,b],{k,c}]
-sum[f[k,j]*t[i,k,a,b],{k}]
-sum[f[k,c]*t[j,c]*t[i,k,a,b],{k,c}]
-sum[f[k,i]*t[j,k,b,a],{k}]
-sum[f[k,c]*t[i,c]*t[j,k,b,a],{k,c}]
+sum[t[i,c]*t[j,d]*v[a,b,c,d],{c,d}]
+sum[t[i,j,c,d]*v[a,b,c,d],{c,d}]
+sum[t[j,c]*v[a,b,i,c],{c}]
-sum[t[k,b]*v[a,k,i,j],{k}]
+sum[t[i,c]*v[b,a,j,c],{c}]
-sum[t[k,a]*v[b,k,j,i],{k}]
-sum[t[k,d]*t[i,j,c,b]*v[k,a,c,d],{k,c,d}]
-sum[t[i,c]*t[j,k,b,d]*v[k,a,c,d],{k,c,d}]
-sum[t[j,c]*t[k,b]*v[k,a,c,i],{k,c}]
+2*sum[t[j,k,b,c]*v[k,a,c,i],{k,c}]
-sum[t[j,k,c,b]*v[k,a,c,i],{k,c}]
-sum[t[i,c]*t[j,d]*t[k,b]*v[k,a,d,c],{k,c,d}]
+2*sum[t[k,d]*t[i,j,c,b]*v[k,a,d,c],{k,c,d}]
-sum[t[k,b]*t[i,j,c,d]*v[k,a,d,c],{k,c,d}]
-sum[t[j,d]*t[i,k,c,b]*v[k,a,d,c],{k,c,d}]
+2*sum[t[i,c]*t[j,k,b,d]*v[k,a,d,c],{k,c,d}]
-sum[t[i,c]*t[j,k,d,b]*v[k,a,d,c],{k,c,d}]
-sum[t[j,k,b,c]*v[k,a,i,c],{k,c}]
-sum[t[i,c]*t[k,b]*v[k,a,j,c],{k,c}]
-sum[t[i,k,c,b]*v[k,a,j,c],{k,c}]
-sum[t[i,c]*t[j,d]*t[k,a]*v[k,b,c,d],{k,c,d}]
-sum[t[k,d]*t[i,j,a,c]*v[k,b,c,d],{k,c,d}]
-sum[t[k,a]*t[i,j,c,d]*v[k,b,c,d],{k,c,d}]
+2*sum[t[j,d]*t[i,k,a,c]*v[k,b,c,d],{k,c,d}]
-sum[t[j,d]*t[i,k,c,a]*v[k,b,c,d],{k,c,d}]
-sum[t[i,c]*t[j,k,d,a]*v[k,b,c,d],{k,c,d}]
-sum[t[i,c]*t[k,a]*v[k,b,c,j],{k,c}]
+2*sum[t[i,k,a,c]*v[k,b,c,j],{k,c}]
-sum[t[i,k,c,a]*v[k,b,c,j],{k,c}]
+2*sum[t[k,d]*t[i,j,a,c]*v[k,b,d,c],{k,c,d}]
-sum[t[j,d]*t[i,k,a,c]*v[k,b,d,c],{k,c,d}]
-sum[t[j,c]*t[k,a]*v[k,b,i,c],{k,c}]
-sum[t[j,k,c,a]*v[k,b,i,c],{k,c}]
-sum[t[i,k,a,c]*v[k,b,j,c],{k,c}]
+sum[t[i,c]*t[j,d]*t[k,a]*t[l,b]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[k,b]*t[l,d]*t[i,j,a,c]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[k,a]*t[l,d]*t[i,j,c,b]*v[k,l,c,d],{k,l,c,d}]
+sum[t[k,a]*t[l,b]*t[i,j,c,d]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[j,c]*t[l,d]*t[i,k,a,b]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[j,d]*t[l,b]*t[i,k,a,c]*v[k,l,c,d],{k,l,c,d}]
+sum[t[j,d]*t[l,b]*t[i,k,c,a]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[i,c]*t[l,d]*t[j,k,b,a]*v[k,l,c,d],{k,l,c,d}]
+sum[t[i,c]*t[l,a]*t[j,k,b,d]*v[k,l,c,d],{k,l,c,d}]
+sum[t[i,c]*t[l,b]*t[j,k,d,a]*v[k,l,c,d],{k,l,c,d}]
+sum[t[i,k,c,d]*t[j,l,b,a]*v[k,l,c,d],{k,l,c,d}]
+4*sum[t[i,k,a,c]*t[j,l,b,d]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[i,k,c,a]*t[j,l,b,d]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[i,k,a,b]*t[j,l,c,d]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[i,k,a,c]*t[j,l,d,b]*v[k,l,c,d],{k,l,c,d}]
+sum[t[i,k,c,a]*t[j,l,d,b]*v[k,l,c,d],{k,l,c,d}]
+sum[t[i,c]*t[j,d]*t[k,l,a,b]*v[k,l,c,d],{k,l,c,d}]
+sum[t[i,j,c,d]*t[k,l,a,b]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[i,j,c,b]*t[k,l,a,d]*v[k,l,c,d],{k,l,c,d}]
-2*sum[t[i,j,a,c]*t[k,l,b,d]*v[k,l,c,d],{k,l,c,d}]
+sum[t[j,c]*t[k,b]*t[l,a]*v[k,l,c,i],{k,l,c}]
+sum[t[l,c]*t[j,k,b,a]*v[k,l,c,i],{k,l,c}]
-2*sum[t[l,a]*t[j,k,b,c]*v[k,l,c,i],{k,l,c}]
+sum[t[l,a]*t[j,k,c,b]*v[k,l,c,i],{k,l,c}]
-2*sum[t[k,c]*t[j,l,b,a]*v[k,l,c,i],{k,l,c}]
+sum[t[k,a]*t[j,l,b,c]*v[k,l,c,i],{k,l,c}]
+sum[t[k,b]*t[j,l,c,a]*v[k,l,c,i],{k,l,c}]
+sum[t[j,c]*t[l,k,a,b]*v[k,l,c,i],{k,l,c}]
+sum[t[i,c]*t[k,a]*t[l,b]*v[k,l,c,j],{k,l,c}]
+sum[t[l,c]*t[i,k,a,b]*v[k,l,c,j],{k,l,c}]
-2*sum[t[l,b]*t[i,k,a,c]*v[k,l,c,j],{k,l,c}]
+sum[t[l,b]*t[i,k,c,a]*v[k,l,c,j],{k,l,c}]
+sum[t[i,c]*t[k,l,a,b]*v[k,l,c,j],{k,l,c}]
+sum[t[j,c]*t[l,d]*t[i,k,a,b]*v[k,l,d,c],{k,l,c,d}]
+sum[t[j,d]*t[l,b]*t[i,k,a,c]*v[k,l,d,c],{k,l,c,d}]
+sum[t[j,d]*t[l,a]*t[i,k,c,b]*v[k,l,d,c],{k,l,c,d}]
-2*sum[t[i,k,c,d]*t[j,l,b,a]*v[k,l,d,c],{k,l,c,d}]
-2*sum[t[i,k,a,c]*t[j,l,b,d]*v[k,l,d,c],{k,l,c,d}]
+sum[t[i,k,c,a]*t[j,l,b,d]*v[k,l,d,c],{k,l,c,d}]
+sum[t[i,k,a,b]*t[j,l,c,d]*v[k,l,d,c],{k,l,c,d}]
+sum[t[i,k,c,b]*t[j,l,d,a]*v[k,l,d,c],{k,l,c,d}]
+sum[t[i,k,a,c]*t[j,l,d,b]*v[k,l,d,c],{k,l,c,d}]
+sum[t[k,a]*t[l,b]*v[k,l,i,j],{k,l}]
+sum[t[k,l,a,b]*v[k,l,i,j],{k,l}]
+sum[t[k,b]*t[l,d]*t[i,j,a,c]*v[l,k,c,d],{k,l,c,d}]
+sum[t[k,a]*t[l,d]*t[i,j,c,b]*v[l,k,c,d],{k,l,c,d}]
+sum[t[i,c]*t[l,d]*t[j,k,b,a]*v[l,k,c,d],{k,l,c,d}]
-2*sum[t[i,c]*t[l,a]*t[j,k,b,d]*v[l,k,c,d],{k,l,c,d}]
+sum[t[i,c]*t[l,a]*t[j,k,d,b]*v[l,k,c,d],{k,l,c,d}]
+sum[t[i,j,c,b]*t[k,l,a,d]*v[l,k,c,d],{k,l,c,d}]
+sum[t[i,j,a,c]*t[k,l,b,d]*v[l,k,c,d],{k,l,c,d}]
-2*sum[t[l,c]*t[i,k,a,b]*v[l,k,c,j],{k,l,c}]
+sum[t[l,b]*t[i,k,a,c]*v[l,k,c,j],{k,l,c}]
+sum[t[l,a]*t[i,k,c,b]*v[l,k,c,j],{k,l,c}]
+v[a,b,i,j]


# *************************************************************
# *************************************************************
# Explicit Equations Part B:  hbar Elements
# *************************************************************
# *************************************************************

# The following definition would result in correct code, but
# the generated function will clash with a later function of
# the same name.
#hbar[i,j,a,b]==
#v[i,j,a,b]

hbar[i,a]==
f[i,a]
+2*sum[t[k,c]*v[i,k,a,c],{k,c}]
-sum[t[k,c]*v[i,k,c,a],{k,c}]

hbar[j,i,a,k]==
sum[t[k,c]*v[i,j,c,a],{c}]
+v[j,i,a,k]

hbar[i,a,b,c]==
-sum[t[k,a]*v[i,k,b,c],{k}]
+v[i,a,b,c]

hbar[a,b]==
f[a,b]
-sum[f[k,b]*t[k,a],{k}]
-sum[t[k,c]*v[k,a,b,c],{k,c}]
+2*sum[t[k,c]*v[k,a,c,b],{k,c}]
-2*sum[t[k,a]*t[l,c]*v[k,l,b,c],{k,l,c}]
-2*sum[t[k,l,a,c]*v[k,l,b,c],{k,l,c}]
+sum[t[k,a]*t[l,c]*v[l,k,b,c],{k,l,c}]
+sum[t[k,l,a,c]*v[l,k,b,c],{k,l,c}]

hbar[i,j]==
f[i,j]
+sum[f[i,c]*t[j,c],{c}]
-sum[t[j,d]*t[k,c]*v[i,k,c,d],{k,c,d}]
+2*sum[t[j,c]*t[k,d]*v[i,k,c,d],{k,c,d}]
+2*sum[t[j,k,c,d]*v[i,k,c,d],{k,c,d}]
-sum[t[j,k,d,c]*v[i,k,c,d],{k,c,d}]
-sum[t[k,c]*v[i,k,c,j],{k,c}]
+2*sum[t[k,c]*v[k,i,c,j],{k,c}]

hbar[i,a,b,j]==
sum[t[j,c]*v[i,a,b,c],{c}]
-sum[t[j,c]*t[k,a]*v[i,k,b,c],{k,c}]
+2*sum[t[j,k,a,c]*v[i,k,b,c],{k,c}]
-sum[t[j,k,c,a]*v[i,k,b,c],{k,c}]
-sum[t[k,a]*v[i,k,b,j],{k}]
-sum[t[j,k,a,c]*v[i,k,c,b],{k,c}]
+v[i,a,b,j]

hbar[i,a,j,b]==
sum[t[j,c]*v[i,a,c,b],{c}]
-sum[t[j,c]*t[k,a]*v[i,k,c,b],{k,c}]
-sum[t[j,k,c,a]*v[i,k,c,b],{k,c}]
-sum[t[k,a]*v[k,i,b,j],{k}]
+v[i,a,j,b]

hbar[i,j,k,l]==
sum[t[k,c]*t[l,d]*v[i,j,c,d],{c,d}]
+sum[t[k,l,c,d]*v[i,j,c,d],{c,d}]
+sum[t[k,c]*v[i,j,c,l],{c}]
+sum[t[l,c]*v[j,i,c,k],{c}]
+v[i,j,k,l]

hbar[a,b,c,d]==
-sum[t[k,b]*v[k,a,d,c],{k}]
-sum[t[k,a]*v[k,b,c,d],{k}]
+sum[t[k,a]*t[l,b]*v[k,l,c,d],{k,l}]
+sum[t[k,l,a,b]*v[k,l,c,d],{k,l}]
+v[a,b,c,d]

hbar[a,b,i,c]==
-sum[f[k,c]*t[i,k,a,b],{k}]
+sum[t[i,d]*v[a,b,d,c],{d}]
-sum[t[i,d]*t[k,b]*v[k,a,c,d],{k,d}]
-sum[t[i,k,d,b]*v[k,a,c,d],{k,d}]
-sum[t[k,b]*v[k,a,c,i],{k}]
-sum[t[i,k,a,d]*v[k,b,c,d],{k,d}]
-sum[t[i,d]*t[k,a]*v[k,b,d,c],{k,d}]
+2*sum[t[i,k,a,d]*v[k,b,d,c],{k,d}]
-sum[t[i,k,d,a]*v[k,b,d,c],{k,d}]
-sum[t[k,a]*v[k,b,i,c],{k}]
-2*sum[t[l,d]*t[i,k,a,b]*v[k,l,c,d],{k,l,d}]
+sum[t[l,b]*t[i,k,a,d]*v[k,l,c,d],{k,l,d}]
+sum[t[l,a]*t[i,k,d,b]*v[k,l,c,d],{k,l,d}]
+sum[t[k,b]*t[l,a]*v[k,l,c,i],{k,l}]
+sum[t[l,k,a,b]*v[k,l,c,i],{k,l}]
+sum[t[i,d]*t[k,a]*t[l,b]*v[l,k,c,d],{k,l,d}]
+sum[t[l,d]*t[i,k,a,b]*v[l,k,c,d],{k,l,d}]
-2*sum[t[l,b]*t[i,k,a,d]*v[l,k,c,d],{k,l,d}]
+sum[t[l,b]*t[i,k,d,a]*v[l,k,c,d],{k,l,d}]
+sum[t[i,d]*t[k,l,a,b]*v[l,k,c,d],{k,l,d}]
+v[a,b,i,c]

hbar[a,i,k,j]==
sum[f[i,c]*t[j,k,c,a],{c}]
+sum[t[j,c]*t[k,d]*v[i,a,c,d],{c,d}]
+sum[t[j,k,c,d]*v[i,a,c,d],{c,d}]
+sum[t[j,c]*v[i,a,c,k],{c}]
+sum[t[k,c]*v[i,a,j,c],{c}]
-sum[t[j,c]*t[k,d]*t[l,a]*v[i,l,c,d],{l,c,d}]
+2*sum[t[l,d]*t[j,k,c,a]*v[i,l,c,d],{l,c,d}]
-sum[t[l,a]*t[j,k,c,d]*v[i,l,c,d],{l,c,d}]
-sum[t[l,c]*t[j,k,d,a]*v[i,l,c,d],{l,c,d}]
-sum[t[k,d]*t[j,l,c,a]*v[i,l,c,d],{l,c,d}]
-sum[t[j,d]*t[k,l,a,c]*v[i,l,c,d],{l,c,d}]
+2*sum[t[j,c]*t[k,l,a,d]*v[i,l,c,d],{l,c,d}]
-sum[t[j,c]*t[k,l,d,a]*v[i,l,c,d],{l,c,d}]
-sum[t[k,l,a,c]*v[i,l,c,j],{l,c}]
-sum[t[j,c]*t[l,a]*v[i,l,c,k],{l,c}]
-sum[t[j,l,c,a]*v[i,l,c,k],{l,c}]
-sum[t[l,a]*v[i,l,j,k],{l}]
-sum[t[k,c]*t[l,a]*v[l,i,c,j],{l,c}]
+2*sum[t[k,l,a,c]*v[l,i,c,j],{l,c}]
-sum[t[k,l,c,a]*v[l,i,c,j],{l,c}]
+v[a,i,k,j]
